# remirepo/Fedora spec file for php-zendframework-zend-filter
#
# Copyright (c) 2015-2017 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    b8d0ff872f126631bf63a932e33aa2d22d467175
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-filter
%global php_home     %{_datadir}/php
%global library      Filter
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif
%global php_version  %(php -r 'echo PHP_VERSION;')

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.7.2
Release:        5%{?dist}
Summary:        Zend Framework %{library} component

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.5
BuildRequires:  php-date
BuildRequires:  php-iconv
BuildRequires:  php-mbstring
BuildRequires:  php-mcrypt
BuildRequires:  php-pcre
BuildRequires:  php-spl
BuildRequires:  php-zip
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7
# From composer, "require-dev": {
#        "pear/archive_tar": "^1.4",
#        "zendframework/zend-crypt": "^2.6 || ^3.0",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3",
#        "zendframework/zend-uri": "^2.5",
#        "phpunit/PHPUnit": "^6.0.10 || ^5.7.17",
#        "zendframework/zend-coding-standard": "~1.0.0"
BuildRequires:  php-autoloader(pear/archive_tar)                >= 1.4
BuildRequires:  php-autoloader(%{gh_owner}/zend-crypt)          >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-uri)            >= 2.5
%if 0%{?fedora} >= 26
%global phpunit %{_bindir}/phpunit6
%else
%global phpunit %{_bindir}/phpunit
%endif
BuildRequires:  %{phpunit}
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.5 || ^7.0",
#        "zendframework/zend-stdlib": "^2.7 || ^3.0"
Requires:       php(language) >= 5.5
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         <  4
%if ! %{bootstrap}
# From composer, "suggest": {
#        "zendframework/zend-crypt": "Zend\\Crypt component",
#        "zendframework/zend-i18n": "Zend\\I18n component",
#        "zendframework/zend-servicemanager": "Zend\\ServiceManager component",
#        "zendframework/zend-uri": "Zend\\Uri component for UriNormalize filter"
%if 0%{?fedora} >= 21
Suggests:       php-autoloader(%{gh_owner}/zend-crypt)
Suggests:       php-autoloader(%{gh_owner}/zend-i18n)
Suggests:       php-autoloader(%{gh_owner}/zend-servicemanager)
Suggests:       php-autoloader(%{gh_owner}/zend-uri)
%endif
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.5.2
Requires:       php-date
Requires:       php-iconv
Requires:       php-mbstring
Requires:       php-pcre
Requires:       php-spl
Requires:       php-zip

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
The Zend\Filter component provides a set of commonly needed data filters.
It also provides a simple filter chaining mechanism by which multiple
filters may be applied to a single datum in a user-defined order.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Stdlib/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Crypt/autoload.php',
    '%{php_home}/Zend/I18n/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/Uri/autoload.php',
    '%{_datadir}/pear/Archive/Tar/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

# Need investigation
rm test/Compress/SnappyTest.php

ret=0
for cmd in "php %{phpunit}" "php70 %{_bindir}/phpunit6" "php71 %{_bindir}/phpunit6" "php72 %{_bindir}/phpunit6"; do
  if which $cmd; then
    set $cmd
    $1 $2 || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.7.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Tue Dec 19 2017 Remi Collet <remi@remirepo.net> - 2.7.2-4
- use Archive_Tar autoloader

* Thu Dec  7 2017 Remi Collet <remi@remirepo.net> - 2.7.2-3
- switch from zend-loader to fedora/autoloader

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.7.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Mon May 22 2017 Remi Collet <remi@remirepo.net> - 2.7.2-1
- Update to 2.7.2
- use phpunit6 on F26+

* Wed Feb 22 2017 Remi Collet <remi@fedoraproject.org> - 2.7.1-3
- don't convertErrorsToExceptions, fix FTBFS #1424085

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.7.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Fri Nov 25 2016 Remi Collet <remi@fedoraproject.org> - 2.7.1-2
- fix FTBFS, disable E_DEPRECATED during test suite

* Tue Apr 19 2016 Remi Collet <remi@fedoraproject.org> - 2.7.1-1
- update to 2.7.1

* Wed Apr  6 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- update to 2.7.0

* Fri Feb 12 2016 Remi Collet <remi@fedoraproject.org> - 2.6.1-1
- update to 2.6.1

* Fri Feb  5 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0
- raise dependency on PHP >= 5.5
- raise dependency on zend-stdlib >= 2.7

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Oct  1 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- normal build

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-0
- initial package, bootstrap build
